#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Lab2.h"

ANIMAL :: ANIMAL (char *name) {  setname (name); }
ANIMAL :: ANIMAL (const ANIMAL &src) { setname (src.name); }
char * ANIMAL :: getname () { return this->name; }

void ANIMAL :: setname (char *name) {
 int n = strlen (name);
 if (n>0) {
  // -    ,  筮  
  this->name = (char *) calloc (strlen(name),sizeof(char));
  if (this->name!=NULL) strcpy (this->name,name);
 }
}

void ANIMAL :: add () {
 if (count<size) {
  animals[count++] = this;
  if (count<size) animals[count] = NULL;
 }
}

void ANIMAL :: print () {
 printf ("ᥣ: %d\n",count);
 for (int i=0; i<count; i++)
  if (animals[i]!=NULL) animals[i]->show();
}

MAMMAL :: MAMMAL (char *name) : ANIMAL (name) {}
void MAMMAL :: show () { printf ("MAMMAL: %s\n",name); }

BIRD :: BIRD (char *name) : ANIMAL (name) {}
void BIRD :: show () { printf ("BIRD: %s\n",name); }

HOOFED :: HOOFED (char *name) : MAMMAL (name) {}
void HOOFED :: show () { printf ("HOOFED: %s\n",name); }
