#ifndef ANIMALH
#define ANIMALH
 class ANIMAL {
  protected:
   char *name;
  public:
   ANIMAL(): name (NULL) {}
   ANIMAL (char *);
   ANIMAL (const ANIMAL&);
   virtual ~ANIMAL() {};
   char * getname();
   void setname (char *);
   virtual void show (void) = 0;
   static void print(void); // ᬮ ᯨ᪠
   void add ();
   static int count;
   static ANIMAL **animals;
   static ANIMAL *begin; // 㪠⥫  砫 ᯨ᪠
 };
 class MAMMAL : public ANIMAL {
 public:
  MAMMAL(): ANIMAL(NULL) {}
  MAMMAL (char *);
  ~MAMMAL() { free (name); }
  void show (void);
 };
 class BIRD : public ANIMAL {
 public:
  BIRD(): ANIMAL(NULL) {}
  BIRD (char *);
  ~BIRD() { free (name); }
  void show (void);
 };
 class HOOFED : public MAMMAL {
 public:
  HOOFED(): MAMMAL(NULL) {}
  HOOFED (char *);
  ~HOOFED() { free (name); }
  void show (void);
 };
 // ᪨  樠㥬  ᠭ 
 int ANIMAL :: count = 0;
 const int size = 4; //। ࠧ ᯨ᪠
 ANIMAL ** ANIMAL::animals = new ANIMAL * [size];
 ANIMAL * ANIMAL ::begin =  ANIMAL ::animals[0];
  // ᯮ,   樨
#endif